import { emptyObject, mergeObjects, updateObjectValue as replaceObjectValueHelper, removeObjectKeys as deleteObjectValueHelper, removeObjectKeys as deleteObjectValuesHelper } from './objectCRUD';
import { DUMMY_OBJECT } from './constants';
let object = DUMMY_OBJECT;

const handleObjectCRUD = () => {
  const setObjectValue = newObject => {
    const modifiedObject = mergeObjects({
      object,
      newObject
    });
    object = modifiedObject; // return modifiedObject
  };

  const clearObjectValue = () => {
    const modifiedObject = emptyObject();
    object = modifiedObject; // return modifiedObject
  };

  const updateObjectValue = (key, value) => {
    const modifiedObject = replaceObjectValueHelper({
      object,
      key,
      value
    });
    object = modifiedObject; // return modifiedObject
  };

  const removeObjectKeys = keys => {
    const modifiedObject = deleteObjectValuesHelper({
      object,
      keys
    });
    object = modifiedObject; // return modifiedObject
  };

  const removeObjectKey = key => {
    const modifiedObject = deleteObjectValueHelper({
      object,
      key
    });
    object = modifiedObject; // return modifiedObject
  };

  return {
    setObjectValue,
    clearObjectValue,
    updateObjectValue,
    removeObjectKeys,
    removeObjectKey,
    getObject: () => object
  };
};

export default handleObjectCRUD;